Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_fifo_testbench_assert.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_fifo_testbench_assert.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_fifo_testbench_assert.cpp	(revision 88)
@@ -0,0 +1,51 @@
+#ifdef VHDL_TESTBENCH
+#ifdef VHDL_TESTBENCH_ASSERT
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/Interface_fifo.h"
+
+namespace morpheo              {
+namespace behavioural          {
+
+#undef  FUNCTION
+#define FUNCTION "Interface_fifo::testbench_assert"
+  void Interface_fifo::testbench_assert (Vhdl * & vhdl,
+                                         std::string counter_name)
+  {
+    log_printf(FUNC,Behavioural,FUNCTION,"Begin");
+    
+    if (not _test_exhaustive)
+      if (_list_cycle->empty()== false)
+        {
+          std::string test_name = Interface::testbench_test_name(vhdl);
+
+          vhdl->set_body("");
+          vhdl->set_body("-- Interface \""+_name+"\"");
+          vhdl->set_body("");
+          
+          uint32_t j = 0;
+          std::list<uint32_t>::iterator i = _list_cycle->begin();
+          
+          while (i != _list_cycle->end())
+            {
+              vhdl->set_body("assert not (("+counter_name+" = "+toString(*i)+" and "+test_name+" = '1')) report \"***** <"+_name+"> Test number "+toString(j)+" is OK     *****\" severity NOTE;");
+              vhdl->set_body("assert not (("+counter_name+" = "+toString(*i)+" and "+test_name+" = '0')) report \"@@@@@ <"+_name+"> Test number "+toString(j)+" is KO !!! @@@@@\" severity NOTE;");
+              j++;
+              ++i;
+            }
+          
+          vhdl->set_body("");
+        }
+    
+    log_printf(FUNC,Behavioural,FUNCTION,"End");
+  };
+
+}; // end namespace behavioural          
+}; // end namespace morpheo              
+#endif
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_fifo_testbench_test.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_fifo_testbench_test.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_fifo_testbench_test.cpp	(revision 88)
@@ -13,6 +13,6 @@
 
   std::string Interface_fifo::testbench_test (Vhdl * & vhdl,
-					 std::string   counter_name,
-					 std::string   reset_name  )
+                                              std::string   counter_name,
+                                              std::string   reset_name  )
   {
     log_printf(FUNC,Behavioural,"testbench_test","Begin");
@@ -27,5 +27,5 @@
 	vhdl->set_body("");
 
-	       test_name        = testbench_test_name        (vhdl);
+	            test_name        = testbench_test_name        (vhdl);
 	std::string test_name_tmp    = test_name+"_tmp";
 	std::string test_name_ok     = testbench_test_ok          (vhdl);
@@ -54,25 +54,25 @@
 	vhdl->set_body(test_name + " <= '1' when ("+reset_name+" = '0') else "+test_name_tmp+";");
 
-#ifdef VHDL_TESTBENCH_ASSERT
-	if (_list_cycle->empty()== false)
-	  {
-	    vhdl->set_body("");
-	    vhdl->set_body("-- Assert ...");
-	    vhdl->set_body("");
+// #ifdef VHDL_TESTBENCH_ASSERT
+// 	if (_list_cycle->empty()== false)
+// 	  {
+// 	    vhdl->set_body("");
+// 	    vhdl->set_body("-- Assert ...");
+// 	    vhdl->set_body("");
 
-	    uint32_t                 j = 0;
-	    std::list<uint32_t>::iterator i = _list_cycle->begin();
+// 	    uint32_t                 j = 0;
+// 	    std::list<uint32_t>::iterator i = _list_cycle->begin();
 	    
-	    while (i != _list_cycle->end())
-	      {
-		vhdl->set_body("assert not (("+counter_name+" = "+toString(*i)+" and "+test_name+" = '1')) report \"***** <"+_name+"> Test number "+toString(j)+" is OK     *****\" severity NOTE;");
-		vhdl->set_body("assert not (("+counter_name+" = "+toString(*i)+" and "+test_name+" = '0')) report \"@@@@@ <"+_name+"> Test number "+toString(j)+" is KO !!! @@@@@\" severity NOTE;");
-		j++;
-		++i;
-	      }
+// 	    while (i != _list_cycle->end())
+// 	      {
+// 		vhdl->set_body("assert not (("+counter_name+" = "+toString(*i)+" and "+test_name+" = '1')) report \"***** <"+_name+"> Test number "+toString(j)+" is OK     *****\" severity NOTE;");
+// 		vhdl->set_body("assert not (("+counter_name+" = "+toString(*i)+" and "+test_name+" = '0')) report \"@@@@@ <"+_name+"> Test number "+toString(j)+" is KO !!! @@@@@\" severity NOTE;");
+// 		j++;
+// 		++i;
+// 	      }
 
-	    vhdl->set_body("");
-	  }
-#endif
+// 	    vhdl->set_body("");
+// 	  }
+// #endif
       }
 
@@ -80,5 +80,4 @@
 
     return test_name;
-
   };
 
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_test_map.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_test_map.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_test_map.cpp	(revision 88)
@@ -18,8 +18,8 @@
     log_printf(FUNC,Behavioural,FUNCTION,"Begin");
 
-    std::string tab  = std::string(depth,'\t');
+    std::string tab  = std::string(depth,' ');
     bool _return = true;
 
-    log_printf(NONE,Behavioural,FUNCTION, "%s* Interface \"%s\"",tab.c_str(),_name.c_str());
+    log_printf(INFO,Interface,FUNCTION, "%s* Interface \"%s\"",tab.c_str(),_name.c_str());
     
     for (std::list<Signal*>::iterator i  = _list_signal->begin();
@@ -42,5 +42,5 @@
 //     bool _return = true;
 
-//     log_printf(NONE,Behavioural,FUNCTION, "%s* Interface \"%s\"",tab.c_str(),_name.c_str());
+//     log_printf(INFO,Behavioural,FUNCTION, "%s* Interface \"%s\"",tab.c_str(),_name.c_str());
     
 //     for (std::list<Signal*>::iterator i  = _list_signal->begin();
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interfaces_test_map.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interfaces_test_map.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interfaces_test_map.cpp	(revision 88)
@@ -18,9 +18,9 @@
     log_printf(FUNC,Behavioural,FUNCTION,"Begin");
 
-    std::string tab  = std::string(depth,'\t');
+    std::string tab  = std::string(depth,' ');
 
     bool _return = true;
 
-    log_printf(NONE,Behavioural,FUNCTION, "%s* Interfaces \"%s\"",tab.c_str(),_name.c_str());
+    log_printf(INFO,Interface,FUNCTION, "%s* Interfaces \"%s\"",tab.c_str(),_name.c_str());
     
     for (std::list<Interface_fifo*>::iterator i  = _list_interface->begin();
@@ -44,5 +44,5 @@
 //     bool _return = true;
 
-//     log_printf(NONE,Behavioural,FUNCTION, "%s* Interfaces \"%s\"",tab.c_str(),_name.c_str());
+//     log_printf(INFO,Behavioural,FUNCTION, "%s* Interfaces \"%s\"",tab.c_str(),_name.c_str());
     
 //     for (std::list<Interface_fifo*>::iterator i  = _list_interface->begin();
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interfaces_testbench_generate_file.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interfaces_testbench_generate_file.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interfaces_testbench_generate_file.cpp	(revision 88)
@@ -17,11 +17,11 @@
     log_printf(FUNC,Behavioural,"generate_file","Begin");
 
-    Vhdl   * vhdl        = new Vhdl(_name+"_Testbench");
-    std::string   counter     = "counter";
-    Signal * clock       = this->get_clock();
-    Signal * reset       = this->get_reset();
-    std::string   clock_name  = clock->get_name();
-    std::string   reset_name  = reset->get_name();
-    uint32_t cycle       = this->get_cycle();
+    Vhdl   *    vhdl        = new Vhdl(_name+"_Testbench");
+    std::string counter     = "counter";
+    Signal *    clock       = this->get_clock();
+    Signal *    reset       = this->get_reset();
+    std::string clock_name  = clock->get_name();
+    std::string reset_name  = reset->get_name();
+    uint32_t    cycle       = this->get_cycle();
 
     vhdl->set_signal    (clock_name, 1, 0);
@@ -87,14 +87,25 @@
     vhdl->set_body("\t\t\t"+counter+" <= "+counter+"+1;");
     vhdl->set_body("");
-    vhdl->set_body("\t\t\tassert not ("+counter+" >= "+toString(cycle)+") report \"Test OK\" severity FAILURE;");
-    vhdl->set_body("\t\t\tassert not ("+test_name+" = '0') report \"Test KO\" severity FAILURE;");
-
 #ifdef VHDL_TESTBENCH_ASSERT
-    vhdl->set_body("\t\t\t-- Assert ...");
     for (uint32_t cpt=0; cpt<=cycle; cpt++)
       vhdl->set_body("\t\t\tassert not ("+counter+" = "+toString(cpt)+") report \"===== Test number "+toString(cpt)+" =====\" severity NOTE;");
+
+    for (std::list<Interface_fifo*>::iterator it=_list_interface->begin();
+         it!=_list_interface->end();
+         ++it)
+      {
+        Vhdl * vhdl_assert = new Vhdl("");
+
+        (*it)->testbench_assert (vhdl_assert,counter);
+
+        vhdl->set_body(vhdl_assert);
+        
+        delete vhdl_assert;
+      }
 #endif
 
     vhdl->set_body("");
+    vhdl->set_body("\t\t\tassert not ("+counter+" >= "+toString(cycle)+") report \"Test OK\" severity FAILURE;");
+    vhdl->set_body("\t\t\tassert not ("+test_name+" = '0') report \"Test KO\" severity FAILURE;");
     vhdl->set_body("\t\tend if;");
     vhdl->set_body("\tend if;");
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Parameters_copy.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Parameters_copy.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Parameters_copy.cpp	(revision 88)
@@ -0,0 +1,76 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/Parameters.h"
+
+namespace morpheo              {
+namespace behavioural          {
+
+#undef  FUNCTION
+#define FUNCTION "Parameters::duplicate" 
+  void Parameters::duplicate (Parameters * param)
+  {
+    param->_simulation_nb_cyle                    = _simulation_nb_cyle                    ;
+    param->_simulation_nb_instruction             = _simulation_nb_instruction             ;
+
+    param->_size_context_id                       = _size_context_id                       ;
+    param->_have_port_context_id                  = _have_port_context_id                  ;
+    
+    param->_size_front_end_id                     = _size_front_end_id                     ;
+    param->_have_port_front_end_id                = _have_port_front_end_id                ;
+
+    param->_size_ooo_engine_id                    = _size_ooo_engine_id                    ;
+    param->_have_port_ooo_engine_id               = _have_port_ooo_engine_id               ;
+
+    param->_size_instruction_address              = _size_instruction_address              ;
+//  param->_have_port_instruction_address         = _have_port_instruction_address         ; // always true
+    
+    param->_size_data_address                     = _size_data_address                     ;
+//  param->_have_port_data_address                = _have_port_data_address                ; // always true
+
+    param->_size_nb_inst_decod                    = _size_nb_inst_decod                    ;
+//  param->_have_port_nb_inst_decod               = _have_port_nb_inst_decod               ; // always true
+
+    param->_size_nb_inst_commit                   = _size_nb_inst_commit                   ;
+//  param->_have_port_nb_inst_commit              = _have_port_nb_inst_commit              ; // always true
+
+    param->_size_depth                            = _size_depth                            ;
+    param->_have_port_depth                       = _have_port_depth                       ;
+
+    param->_size_ifetch_queue_ptr                 = _size_ifetch_queue_ptr                 ;
+    param->_have_port_ifetch_queue_ptr            = _have_port_ifetch_queue_ptr            ;
+
+    param->_size_inst_ifetch_ptr                  = _size_inst_ifetch_ptr                  ; // nb_inst_fetch
+    param->_have_port_inst_ifetch_ptr             = _have_port_inst_ifetch_ptr             ;
+
+//  param->_size_branch_update_prediction_id      = _size_branch_update_prediction_id      ; // = size_depth
+//  param->_have_port_branch_update_prediction_id = _have_port_branch_update_prediction_id ; // = size_depth
+
+    param->_size_rob_ptr                          = _size_rob_ptr                          ;
+    param->_have_port_rob_ptr                     = _have_port_rob_ptr                     ;
+
+    param->_size_load_queue_ptr                   = _size_load_queue_ptr                   ;
+    param->_have_port_load_queue_ptr              = _have_port_load_queue_ptr              ;
+
+    param->_size_store_queue_ptr                  = _size_store_queue_ptr                  ;
+//  param->_have_port_store_queue_ptr             = _have_port_store_queue_ptr             ; // always true (min = 1)
+
+    param->_size_general_data                     = _size_general_data                     ;
+//  param->_have_port_general_data                = _have_port_general_data                ; // always true
+
+    param->_size_special_data                     = _size_special_data                     ;
+//  param->_have_port_special_data                = _have_port_special_data                ; // always true
+
+    param->_size_general_register                 = _size_general_register                 ;
+//  param->_have_port_general_register            = _have_port_general_register            ; // always true
+
+    param->_size_special_register                 = _size_special_register                 ;
+//  param->_have_port_special_register            = _have_port_special_register            ; // always true
+  }
+
+}; // end namespace behavioural          
+}; // end namespace morpheo              
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Parameters_test.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Parameters_test.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Parameters_test.cpp	(revision 88)
@@ -23,5 +23,5 @@
 
     if (x.have_error())
-      throw (ErrorMorpheo ("Error(s) in parameters"));
+      throw ERRORMORPHEO (FUNCTION,_("Error(s) in parameters\n"));
 
     log_printf(FUNC,Behavioural,FUNCTION,"End");
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/SPR_access_mode_exist.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/SPR_access_mode_exist.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/SPR_access_mode_exist.cpp	(revision 88)
@@ -0,0 +1,24 @@
+#include "Behavioural/include/SPR_access_mode.h"
+
+namespace morpheo {
+namespace behavioural {
+
+  bool SPR_access_mode::exist (spr_address_t address)
+  {
+    return exist(address._group, address._register);
+  }
+  
+  bool SPR_access_mode::exist (uint32_t num_group, uint32_t num_reg)
+  {
+    if (not valid(num_group, num_reg))
+      return false;
+
+    spr_access_mode_t mode = _spr_generic [num_group][num_reg];
+
+    return ((mode._supervisor_access_mode != SPR_ACCESS_MODE_NONE) or
+	    (mode._user_access_mode       != SPR_ACCESS_MODE_NONE));
+  }
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/SPR_access_mode_implement_group.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/SPR_access_mode_implement_group.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/SPR_access_mode_implement_group.cpp	(revision 88)
@@ -28,4 +28,6 @@
     	    for (uint32_t i=16; i<=18; i++)
     	    _spr_generic [GROUP_SYSTEM_AND_CONTROL ][   i]._supervisor_access_mode = SPR_ACCESS_MODE_READ_WRITE;
+    	    _spr_generic [GROUP_SYSTEM_AND_CONTROL ][  19]._user_access_mode       = SPR_ACCESS_MODE_READ_ONLY;
+    	    _spr_generic [GROUP_SYSTEM_AND_CONTROL ][  19]._supervisor_access_mode = SPR_ACCESS_MODE_READ_WRITE;
     	    _spr_generic [GROUP_SYSTEM_AND_CONTROL ][  20]._user_access_mode       = SPR_ACCESS_MODE_READ_ONLY_COND;
     	    _spr_generic [GROUP_SYSTEM_AND_CONTROL ][  20]._supervisor_access_mode = SPR_ACCESS_MODE_READ_WRITE;
@@ -77,5 +79,5 @@
 
 	    _spr_generic [GROUP_DCACHE             ][   0]._supervisor_access_mode = SPR_ACCESS_MODE_READ_WRITE;
-	    for (uint32_t i=0; i<=5; i++)
+	    for (uint32_t i=1; i<=5; i++)
 	    	{
 	    _spr_generic [GROUP_DCACHE             ][   i]._supervisor_access_mode = SPR_ACCESS_MODE_WRITE_ONLY;
@@ -91,5 +93,5 @@
 
 	    _spr_generic [GROUP_ICACHE             ][   0]._supervisor_access_mode = SPR_ACCESS_MODE_READ_WRITE;
-	    for (uint32_t i=0; i<=3; i++)
+	    for (uint32_t i=1; i<=3; i++)
 	    	{
 	    _spr_generic [GROUP_ICACHE             ][   i]._supervisor_access_mode = SPR_ACCESS_MODE_WRITE_ONLY;
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/SPR_access_mode_invalid_register.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/SPR_access_mode_invalid_register.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/SPR_access_mode_invalid_register.cpp	(revision 88)
@@ -0,0 +1,14 @@
+#include "Behavioural/include/SPR_access_mode.h"
+
+namespace morpheo {
+namespace behavioural {
+
+  void SPR_access_mode::invalid_register (uint32_t num_group, uint32_t num_reg)
+  {
+    if (valid(num_group, num_reg))
+      change_mode (num_group, num_reg, spr_access_mode_t(SPR_ACCESS_MODE_NONE,SPR_ACCESS_MODE_NONE));
+  }
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/SPR_access_mode_read_write.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/SPR_access_mode_read_write.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/SPR_access_mode_read_write.cpp	(revision 88)
@@ -1,3 +1,5 @@
 #include "Behavioural/include/SPR_access_mode.h"
+
+#include "Common/include/Debug.h"
 
 namespace morpheo {
@@ -14,8 +16,15 @@
   bool SPR_access_mode::read (spr_address_t address, Tcontrol_t SM, Tcontrol_t SUMRA)
     {
-      if (not valid(address))
+//       log_printf(TRACE,true,"SPR_access_mode::read","address [%d][%d]",address._group,address._register);
+//       log_printf(TRACE,true,"SPR_access_mode::read","sm        : %d",SM   );
+//       log_printf(TRACE,true,"SPR_access_mode::read","sumra     : %d",SUMRA);
+
+      if (not exist(address))
 	return false;
 
       spr_access_mode_t mode = _spr_generic [address._group][address._register];
+
+//       log_printf(TRACE,true,"SPR_access_mode::read","kernel    : %d",(int)mode._supervisor_access_mode);
+//       log_printf(TRACE,true,"SPR_access_mode::read","user      : %d",(int)mode._supervisor_access_mode);
 
       return (((SM == 1) and ( (mode._supervisor_access_mode == SPR_ACCESS_MODE_READ_ONLY     ) or
@@ -28,5 +37,5 @@
   bool SPR_access_mode::write(spr_address_t address, Tcontrol_t SM, Tcontrol_t SUMRA)
     {
-      if (not valid(address))
+      if (not exist(address))
 	return false;
 
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Signal_link.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Signal_link.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Signal_link.cpp	(revision 88)
@@ -51,5 +51,5 @@
 //     if (destination_have_multi_producer)
 // //       throw (ERRORMORPHEO (FUNCTION,"Signal \""+_name+"\" can't been linked with signal \""+signal_dest->get_name()+"\" : destination have multi producer."));
-//       log_printf(NONE,Behavioural,FUNCTION,"Signal \"%s\" can't been linked with signal \"%s\" : destination have multi producer.",_name.c_str(),signal_dest->get_name().c_str());
+//       log_printf(INFO,Behavioural,FUNCTION,"Signal \"%s\" can't been linked with signal \"%s\" : destination have multi producer.",_name.c_str(),signal_dest->get_name().c_str());
 
     // update info source
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Signal_test_map.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Signal_test_map.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Signal_test_map.cpp	(revision 88)
@@ -19,13 +19,13 @@
 
     std::string str     = "";
-    std::string tab     = std::string(depth,'\t');
+    std::string tab     = std::string(depth,' ');
     bool        _return = true;
 
-//     log_printf(NONE,Behavioural,FUNCTION, "%s* Signal \"%s\"",tab.c_str(),_name.c_str());
-//     log_printf(NONE,Behavioural,FUNCTION, "%s%d - %d - %d",tab.c_str(),
+//     log_printf(INFO,Behavioural,FUNCTION, "%s* Signal \"%s\"",tab.c_str(),_name.c_str());
+//     log_printf(INFO,Behavioural,FUNCTION, "%s%d - %d - %d",tab.c_str(),
 // 	       _is_map_as_toplevel_dest,
 // 	       _is_map_as_component_src,
 // 	       _is_map_as_component_dest);
-//     log_printf(NONE,Behavioural,FUNCTION, "%stop_level %d, is_behavioural %d",tab.c_str(),
+//     log_printf(INFO,Behavioural,FUNCTION, "%stop_level %d, is_behavioural %d",tab.c_str(),
 // 	       top_level,
 // 	       is_behavioural);
@@ -143,13 +143,13 @@
     if (_return == false)
       {
-	log_printf(NONE,Behavioural,FUNCTION, "%s* %s",tab.c_str(),str.c_str());
-	
 #ifndef DEBUG
 	std::cerr << str << std::endl;
+#else
+	log_printf(INFO,Interface,FUNCTION, "%s* %s",tab.c_str(),str.c_str());
 #endif
       }
     else
       {
-// 	log_printf(NONE,Behavioural,FUNCTION, "%s* Signal \"%s\" is OK.",tab.c_str(),_name.c_str());
+// 	log_printf(INFO,Interface,FUNCTION, "%s* Signal \"%s\" is OK.",tab.c_str(),_name.c_str());
       }
 
@@ -173,5 +173,5 @@
 //     if (_return == false)
 //       {
-// 	log_printf(NONE,Behavioural,FUNCTION, "%s* %s",tab.c_str(),str.c_str());
+// 	log_printf(INFO,Behavioural,FUNCTION, "%s* %s",tab.c_str(),str.c_str());
 	
 // #ifndef DEBUG
@@ -181,5 +181,5 @@
 //     else
 //       {
-// // 	log_printf(NONE,Behavioural,FUNCTION, "%s* Signal \"%s\" is OK.",tab.c_str(),_name.c_str());
+// // 	log_printf(INFO,Behavioural,FUNCTION, "%s* Signal \"%s\" is OK.",tab.c_str(),_name.c_str());
 //       }
     
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Simulation.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Simulation.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Simulation.cpp	(revision 88)
@@ -0,0 +1,69 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/Simulation.h"
+#include "Common/include/ErrorMorpheo.h"
+
+namespace morpheo              {
+namespace behavioural          {
+
+  static bool            simulation_initialized;
+//   static uint32_t       _simulation_num_context_next;
+  double                _simulation_nb_cycle;
+//   double                _simulation_nb_instruction;
+//   std::vector<double> * _simulation_nb_instruction_commited;
+
+//   Simulation::Simulation (void):
+//     _num_context (_simulation_num_context_next)
+//   {
+//     // Test if is first context create
+//     if (_simulation_num_context_next == 0)
+//       _simulation_nb_instruction_commited = new std::vector<double>;
+
+//     _simulation_num_context_next ++;
+//   }
+  
+//   Simulation::~Simulation (void)
+//   {
+//     _simulation_num_context_next --;
+    
+//     // Test if is last context destroy
+//     if (_simulation_num_context_next == 0)
+//       delete _simulation_nb_instruction_commited;
+//   }
+
+  void simulation_init (double nb_cycle,
+                        double nb_instruction)
+  {
+    if (not simulation_initialized)
+      {
+//         _simulation_num_context_next = 0;
+        _simulation_nb_cycle         = nb_cycle       ;
+//         _simulation_nb_instruction   = nb_instruction;
+
+        if (nb_instruction != 0)
+          throw ERRORMORPHEO("simulation_init",_("Stop Condition on number instruction is not yet implemented"));
+        
+        simulation_initialized = true;
+      }
+    else
+      {
+        msg_printf(WARNING,_("Multi instance of Morpheo : stop condition, take the highest."));
+
+        if (_simulation_nb_cycle < nb_cycle)
+          _simulation_nb_cycle = nb_cycle;
+
+//         if (_simulation_nb_instruction < nb_instruction)
+//           _simulation_nb_instruction = nb_instruction;
+      }
+  }
+    
+}; // end namespace behavioural          
+}; // end namespace morpheo              
+
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Simulation_end_cycle.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Simulation_end_cycle.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Simulation_end_cycle.cpp	(revision 88)
@@ -0,0 +1,23 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/Simulation.h"
+
+namespace morpheo              {
+namespace behavioural          {
+
+//   void Simulation::end_cycle (double nb_instruction_commited)
+//   {
+//     // must test if _simulation_nb_instruction_commited is allocate
+//     (*_simulation_nb_instruction_commited) [_num_context] += nb_instruction_commited;
+//   }
+
+}; // end namespace behavioural          
+}; // end namespace morpheo              
+
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Simulation_test_end.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Simulation_test_end.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Simulation_test_end.cpp	(revision 88)
@@ -0,0 +1,49 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/Simulation.h"
+
+namespace morpheo              {
+namespace behavioural          {
+
+  bool simulation_test_end (void)
+  {
+    msg("##########[ cycle %d ]\n",static_cast<uint32_t>(sc_simulation_time()));
+
+    // Test if a stop condition is activate
+    if ((_simulation_nb_cycle == 0)//  and
+//         (_simulation_nb_instruction == 0)
+        )
+      return false;
+
+    bool end_cycle = true;
+//     bool end_inst  = true;
+
+    if (_simulation_nb_cycle != 0)
+      end_cycle = (_simulation_nb_cycle <= sc_simulation_time());
+
+//     if (_simulation_nb_instruction != 0)
+//       {
+//         std::vector<double>::iterator it=_simulation_nb_instruction_commited->begin();
+        
+//         // Scan all context and test if all can finish
+//         while (end_inst and it!=_simulation_nb_instruction_commited->end())
+//           {
+//             end_inst &= (*it <= _simulation_nb_instruction);
+//             it ++;
+//           }
+//       }
+    
+    return end_cycle // and end_inst
+      ;
+  }
+
+}; // end namespace behavioural          
+}; // end namespace morpheo              
+
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Stat_binary_tree.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Stat_binary_tree.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Stat_binary_tree.cpp	(revision 88)
@@ -21,41 +21,41 @@
   Stat_binary_tree:: Stat_binary_tree (counter_t   cst)
   {
-    _root  = NULL;
-    _left  = NULL;
-    _right = NULL;
+    _root      = NULL;
+    _left      = NULL;
+    _right     = NULL;
+    _data_type = NONE;
 
-    data_t data;
-    data.cst = cst;
-    _data_type   = CONSTANT;
-    _data        = data;
-
-//     Stat_binary_tree(CONSTANT, data);
+    change_type (cst);
   }
   
   Stat_binary_tree:: Stat_binary_tree (counter_t * var)
   {
-    _root  = NULL;
-    _left  = NULL;
-    _right = NULL;
+    _root      = NULL;
+    _left      = NULL;
+    _right     = NULL;
+    _data_type = NONE;
 
-    data_t data;
-    data.var   = var;
-    _data_type = VARIABLE;
-    _data      = data;
-
-//     Stat_binary_tree(VARIABLE, data);
+    change_type (var);
   }
 
   Stat_binary_tree:: Stat_binary_tree (operator_t  op)
   {
-    _root  = NULL;
-    _left  = NULL;
-    _right = NULL;
+    _root      = NULL;
+    _left      = NULL;
+    _right     = NULL;
+    _data_type = NONE;
 
-    data_t data;
-    data.op    = op;
-    _data_type = ((op == inc) or (op == dec))?OPERATOR_UNARY:OPERATOR_BINARY;
-    _data      = data;
+    change_type (op);
+  }
 
+  Stat_binary_tree:: Stat_binary_tree (std::string expr,
+                                       std::map<std::string, counter_t*> * operand)
+  {
+    _root      = NULL;
+    _left      = NULL;
+    _right     = NULL;
+    _data_type = NONE;
+
+    import (expr, operand);
   }
 
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Stat_binary_tree_change_type.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Stat_binary_tree_change_type.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Stat_binary_tree_change_type.cpp	(revision 88)
@@ -0,0 +1,35 @@
+#ifdef STATISTICS
+#include "Behavioural/include/Stat_binary_tree.h"
+
+namespace morpheo {
+namespace behavioural {
+
+  void Stat_binary_tree::change_type (counter_t   cst)
+  {
+    if (_data_type != NONE)
+      throw (ERRORMORPHEO("Stat_binary_tree::change_type",_("To change type, data_type must be \'NONE\'.\n")));
+
+    _data_type = CONSTANT;
+    _data.cst  = cst;
+  }
+
+  void Stat_binary_tree::change_type (counter_t * var)
+  {
+    if (_data_type != NONE)
+      throw (ERRORMORPHEO("Stat_binary_tree::change_type",_("To change type, data_type must be \'NONE\'.\n")));
+
+    _data_type = VARIABLE;
+    _data.var  = var;
+  }
+
+  void Stat_binary_tree::change_type (operator_t  op )
+  {
+    if (_data_type != NONE)
+      throw (ERRORMORPHEO("Stat_binary_tree::change_type",_("To change type, data_type must be \'NONE\'.\n")));
+
+    _data_type = ((op == inc) or (op == dec))?OPERATOR_UNARY:OPERATOR_BINARY;
+    _data.op   = op;
+  }
+};
+};
+#endif
